package io.github.rmuhamedgaliev.service.process;

import io.github.rmuhamedgaliev.model.process.LocalProcess;

import java.util.List;

/**
 * Developer: Muhamedgaliev Rinat
 */
public interface ProcessService
{
    /**
     * Return list process with information
     * @return List<LocalProcess>
     */
    List<LocalProcess> getProcessList();

    /**
     * Return load average system
     * @return double value load average
     */
    double getLoadAverage();

    /**
     * Return list of zombie processes
     * @return list of zombie processes
     */
    List<LocalProcess> getZombieProcessesList();

    /**
     * Return array list filtered by command name or pid
     * @param findParam string param comand or pid requred process
     * @return List<LocalProcess> filtered by comand or pid
     */
    List<LocalProcess> findProcessByCommandOrPID(String findParam);
}
